/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 181 by dpavlin, Tue Mar 16 17:39:28 2010 UTC revision 245 by dpavlin, Tue Mar 29 18:02:44 2011 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /bin/sh
2    ### BEGIN INIT INFO
3    # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15  # lxc-watchdog.sh  # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
 #  
 # Dobrica Pavlinusic <dpavlin@rot13.org> 2010-03-15  
 #  
 # this script can be used to start/stop Linux containers  
 # using clever inotify hack to monitor halt/reboot from  
 # Tony Risinger posted to lxc-users mailing list  
16  #  #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 lxc_status() {  
         lxc-ls -1 | sort -u | xargs -i lxc-info -n {}  
 }  
27    
28  lxc_exists() {  lxc_exists() {
29          name=$1          name=$1
# Line 29  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56    lxc_status() {
57            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                    boot="-"
59                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61            done ) | column -t
62  }  }
63    
64    
# Line 37  cleanup_init_scripts() { Line 66  cleanup_init_scripts() {
66          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
67    
68          ls \          ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
71                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
72                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74                    $rootfs/etc/rc?.d/*checkfs* \
75          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
76    
77            echo $1 > $rootfs/etc/hostname
78            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79  }  }
80    
81    
82  setup_inittab() {  setup_inittab() {
83          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
84            remove=$2
85            add=$3
86    
87          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
88          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
89          powerfail="pw::powerfail:/sbin/init 0"          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
90          if ! grep "$powerfail" ${inittab} >/dev/null ; then                  grep -v "$remove" ${inittab} > ${inittab}.new
91                  grep -v ::power ${inittab} > ${inittab}.new                  echo $add >> ${inittab}.new
                 echo $powerfail >> ${inittab}.new  
92                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
93                  echo "$initab modified"                  echo "$inittab modified with $add"
94          fi          fi
95    }
96    
97    
98    lxc_log() {
99            echo `date +%Y-%m-%dT%H:%M:%S` $*
100  }  }
101    
102    
103  lxc_stop() {  lxc_kill() {
104          name=$1          name=$1
105            sig=$2
106    
107          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
108          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
109                  lxc-info -n $name                  lxc-info -n $name
110                  exit 1                  exit 1
111          fi          fi
112          echo "$name stop $init_pid"          lxc_log "$name kill $sig $init_pid"
113          /bin/kill -SIGPWR $init_pid          /bin/kill $sig $init_pid
114          lxc-wait -n $name -s STOPPED  }
115    
116    lxc_stop() {
117            lxc_log "$name stop"
118            lxc_kill $name -SIGPWR
119            lxc-wait -n $name -s STOPPED
120            lxc_log "$name stoped"
121    #       rm -f /var/lib/lxc/${name}/on_boot
122  }  }
123    
124    
125  lxc_start() {  lxc_start() {
126          name=$1          name=$1
127            rootfs=$(lxc_rootfs $1)
128    
129            if [ ! -e $rootfs ] ; then
130                    echo "ERROR $name rootfs $rootfs not found"
131                    return
132            fi
133    
134          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
135                  echo "$name start"                  lxc_log "$name start"
136                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
137                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
138                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
139                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
140                  lxc-info  -n $name                  lxc-info  -n $name
141                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
142          fi          fi
143  }  }
144    
# Line 91  name=$1 Line 147  name=$1
147  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
148    
149  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
150          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
         inotifywait -qqt 300 ${vps_utmp}  
151          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
152            stop_on=1 # init
153            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
154            if [ "$sulogins" -gt 0 ] ; then
155                    stop_on=`expr $stop_on + $sulogins`
156            fi
157    
158          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
159          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
160    
161                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
162                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
163    
164                  case $runlevel in                  case $runlevel in
165                  N*)                  N*)
166                          # nothing for new boot state                          # nothing for new boot state
167                  ;;                  ;;
168                  ??0)                  ??0)
169                          echo "$name halt"                          lxc_log "$name halt"
170                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
171                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
172                          break                          break
173                  ;;                  ;;
174                  ??6)                  ??6)
175                          echo "$name reboot";                          lxc_log "$name reboot";
176                          lxc-stop -n ${name}                          lxc-stop -n ${name}
177                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
178                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 124  while true; do Line 184  while true; do
184                  ;;                  ;;
185                  esac                  esac
186          else          else
187                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
188          fi          fi
189    
190            # time of 5 minutes on it JUST IN CASE...
191            inotifywait -qqt 300 ${vps_utmp}
192  done  done
193    
194  echo "${name} exited"  lxc_log "$name watchdog exited"
195    
196  }  }
197    
198    
199  case "$1" in  usage() {
200            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
201            exit 3
202    }
203    
204    command_on_lxc() {
205    command=$1
206    shift
207    
208    echo "# $command $1"
209    
210    case "$command" in
211    
212  start)  start)
213          lxc_exists $2          lxc_exists $1
214          cleanup_init_scripts $2          cleanup_init_scripts $1
215          setup_inittab $2          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
216          lxc_start $2          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
217          ( nohup $0 watchdog $2 >> /tmp/$2.log ) &          setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
218          ;;          lxc_start $1
219  stop)          # give container 5 seconds to start more than one process
220          lxc_exists $2          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
221          lxc_stop $2          ;;
222          ;;  stop|halt)
223  status)          lxc_exists $1
224          lxc_status          lxc_stop $1
225          ;;          ;;
226  reload|force-reload|restart)  reload|force-reload|restart|reboot)
227          lxc_stop $2          lxc_kill $1 -SIGINT
         lxc_start $2  
228          ;;          ;;
229  watchdog)  watchdog)
230          lxc_watchdog $2          lxc_watchdog $1
231            ;;
232    boot)
233            echo $1 > /var/lib/lxc/$1/on_boot
234            ;;
235    disable)
236            echo -n > /var/lib/lxc/$1/on_boot
237          ;;          ;;
238  *)  *)
239          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
240          ;;          ;;
241    
242  esac  esac
243    
244    }
245    
246    command=$1
247    test -z "$command" && usage
248    test "$command" = "status" && lxc_status && exit
249    shift
250    
251    if [ -z "$1" ] ; then
252            ls /var/lib/lxc/*/on_boot | while read path ; do
253                    name=`echo $path | cut -d/ -f5`
254                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
255                            command_on_lxc $command $name
256                    else
257                            echo "# skip $command $name"
258                    fi
259            done
260    else
261            while [ ! -z "$1" ] ; do
262                    command_on_lxc $command $1
263                    shift
264            done
265    fi
266    

Legend:
Removed from v.181  
changed lines
  Added in v.245

  ViewVC Help
Powered by ViewVC 1.1.26